QCAT - User Story #1858

Change defined values for different fields in technology questionnaire edition 2018
12 Jul 2019 15:08 - Redmine Admin

Status: Closed Start date: 12 Jul 2019
Priority: High Due date:

Assignee: Kurt Gerber % Done: 0%
Category: Estimated time: 0.00 hour
Target version: Carbon Benefit Spent time: 0.00 hour
Resolution:

Description

Adaptation of the list of predefined values for plants, annual cropping systems, perennial crops, trees, etc
in question '3.2 Current land use type(s) where the Technology is applied'

The list has to conform to the list in the attached word file.

History

#1 - 23 Aug 2019 11:54 - Kurt Gerber

- Assignee changed from Brahadeesh Dheenadayalan_Sivakami to Kurt Gerber

Guhan asks:

| am stuck trying to figure out how to add the new list-item values. When | run the existing fixtures the new CBP edition 2018 values are not
inserted into the database tables (configuration_key, configuration_value and configuration_translation).

| found the editions script that has all the 2018 values (for example cereals-maize) which are returned as a dictionary but | am unable to figure
out how to run this script. Is there some documentation | am missing?

To maintain the existing foreign key relationships | was thinking of using a fixture to append the new values but | am not sure this is the best
approach.

#2 - 23 Aug 2019 11:57 - Kurt Gerber

- Status changed from Accepted to In Progress

#3 - 23 Aug 2019 12:00 - Kurt Gerber

- Assignee changed from Kurt Gerber to Brahadeesh Dheenadayalan_Sivakami

| had to reach my backstopping support for this question (Sebastian/Lukas). | got the following answer:

The configuration for the 2018 edition of the Technologies questionnaire is inserted via a script, it can be run using “python manage.py runscript
technologies_2018". This will create a new configuration (in the DB table “configuration_configuration™ with the values for the edition 2018. The script
itself is in “apps/configuration/scripts/technologies_2018.py" and calls the edition code in “apps/configuration/editions/technologies_2018.py".

If you want to add new values without creating a new edition, I'd suggest to also create a script (e.g. “technologies_2018_1") which calls code (e.g.
“apps/configuration/editions/technologies_2018_1.py’) to update the already existing edition 2018 of the Technologies questionnaire. If your edition
class inherits from “Edition™ in “apps/configuration/editions/base.py’, you could reuse some methods defined there (e.g. create_new_value’). You
should make sure that no new edition is created (I think if you set code = 'technologies' and edition = 2018, it should update the existing edition 2018
instead of creating a new one).

Please note that you should only add new values but not edit existing questions or values (except their translations). Otherwise existing
questionnaires cannot be updated anymore if they reference the edited question.

#4 - 02 Sep 2019 04:12 - Brahadeesh Dheenadayalan_Sivakami

- File LUT lists-newvalues.xlIsx added

Hi Kurt,

| have successfully added scripts (editions/technologies_2018_1 & scripts/technologies_2018_1) to append the new items. | will modify the items
based on the list you shared which | have attached here.

One issue | found with my testing is that each time | run the script to append the values, it resets the configuration back to the 2015 edition. This is
fixed by running the technologies_2018 script but | don't think this is the approach to use on production. | did set the code and edition to technologies
and 2018 in the new script.
If you want | can push my feature branch to Github so you can check my scripts.
Sorry for the trouble. Any help is appreciated.
Kurt Gerber wrote:
| had to reach my backstopping support for this question (Sebastian/Lukas). | got the following answer:

The configuration for the 2018 edition of the Technologies questionnaire is inserted via a script, it can be run using “python manage.py runscript
technologies_2018". This will create a new configuration (in the DB table “configuration_configuration™ with the values for the edition 2018. The
script itself is in “apps/configuration/scripts/technologies_2018.py" and calls the edition code in
“apps/configuration/editions/technologies_2018.py".

If you want to add new values without creating a new edition, I'd suggest to also create a script (e.g. ‘technologies_2018_1") which calls code
(e.g. “apps/configuration/editions/technologies_2018_1.py") to update the already existing edition 2018 of the Technologies questionnaire. If your
edition class inherits from "Edition” in “apps/configuration/editions/base.py’, you could reuse some methods defined there (e.g.
“create_new_value’). You should make sure that no new edition is created (I think if you set code = 'technologies' and edition = 2018, it should
update the existing edition 2018 instead of creating a new one).

Please note that you should only add new values but not edit existing questions or values (except their translations). Otherwise existing
questionnaires cannot be updated anymore if they reference the edited question.

#5 - 03 Sep 2019 18:43 - Brahadeesh Dheenadayalan_Sivakami

- Assignee changed from Brahadeesh Dheenadayalan_Sivakami to Kurt Gerber

#6 - 05 Sep 2019 11:42 - Kurt Gerber

- Assignee changed from Kurt Gerber to Brahadeesh Dheenadayalan_Sivakami

Could you please push your changes (scripts) in a new branch (In git-flow it is called a feature branch) to github?
If you feel unsure, just attach the two scripts.

#7 - 05 Sep 2019 11:53 - Kurt Gerber

Sorry, my error, | forgot that you can only do a pull request.
So, could you please do a pull request?

#8 - 06 Sep 2019 07:44 - Brahadeesh Dheenadayalan_Sivakami
- File apps_configuration.tar added

- Assignee changed from Brahadeesh Dheenadayalan_Sivakami to Kurt Gerber

Hi Kurt,

| have the code on a feature branch but | am not sure how to send a pull request since that branch does not exist on GitHub? Did you mean pull
request to develop?

Nonetheless, I've attached the scripts | have developed in their respective folders <editions and scripts>.

Kurt Gerber wrote:

Sorry, my error, | forgot that you can only do a pull request.
So, could you please do a pull request?

#9 - 06 Sep 2019 16:04 - Kurt Gerber

- Assignee changed from Kurt Gerber to Lukas Vonlanthen

Lukas,
Please read the comments from Guhan and we would be thankfull for a little hint.

#10 - 09 Sep 2019 00:15 - Lukas Vonlanthen

- Assignee changed from Lukas Vonlanthen to Brahadeesh Dheenadayalan_Sivakami

| am afraid the information | have given you earlier was not entirely correct. | am very sorry about that - it has been a while since | have worked with
QCAT in depth.

You are right about the script resetting the previous edition 2018 (the reason being that Edition.get_base_configuration_data() excludes the current
edition, thus returning the data of the edition 2015 as the base data for the changes).

| forgot that the edition scripts can be run repeatedly, even if the edition was already applied. So running python manage.py runscript
technologies_2018 on the server again without any changes to the edition does not have any impact. It also means that it is probably easier to add
the new operations to the existing ones in apps/configuration/editions/technologies_2018.py and then run the script again, which will only create the
new values as the others already exist.

Again, this should only be done with new questions or values. It should not be used to modify existing questions or values.

| hope this helps?

Just a quick note about Pull Requests on Github: In order to create a PR on Github, you have to push your (feature-)branch first, then create a PR
based on this branch. See https://help.github.com/en/articles/about-pull-requests.

#11 - 10 Oct 2019 04:56 - Brahadeesh Dheenadayalan_Sivakami
- Status changed from In Progress to Feedback

- Assignee changed from Brahadeesh Dheenadayalan_Sivakami to Kurt Gerber

Hi Kurt,
| have generated a pull request for this task.
Expecting your feedback and comments on my first submission!

Thanks,
Guhan

#12 - 10 Oct 2019 09:45 - Kurt Gerber

- Assignee changed from Kurt Gerber to Lukas Vonlanthen
Lukas, can you please review the pull request?
#13 - 12 Oct 2019 23:02 - Lukas Vonlanthen

The pull request (https://github.com/CDE-UNIBE/qgcat/pull/48) looks good to me code-wise! | just added a comment about the release notes, but this
is more a formal question. Once that is cleared, | am happy to approve your first PR!

#14 - 14 Oct 2019 09:16 - Kurt Gerber

- Assignee changed from Lukas Vonlanthen to Brahadeesh Dheenadayalan_Sivakami

Concerning the proposal from Lukas:
Please add it a the end by adding: 'Update October 2019: Question 3.2: New annual crops were added...

#15 - 22 Oct 2019 20:18 - Brahadeesh Dheenadayalan_Sivakami

- Assignee changed from Brahadeesh Dheenadayalan_Sivakami to Kurt Gerber

Hi Kurt and Lukas,
| have made the requested change to the previous commit. This should now reflect in the existing pull request.

Thanks,
Guhan

#16 - 30 Oct 2019 23:29 - Brahadeesh Dheenadayalan_Sivakami

A quick question regarding this change issue.
Does the apps/configuration/editions/technologies_2018.py script need to be run so that the list-values are updated and visible on
https://gcat-dev.wocat.net/?

Thanks,
Guhan

#17 - 31 Oct 2019 09:26 - Kurt Gerber

- Assignee changed from Kurt Gerber to Lukas Vonlanthen

Hi Lukas, could you please answer Guhan's last question?
Thanks.

#18 - 31 Oct 2019 20:37 - Lukas Vonlanthen
https://help.github.com/en/articles/about-pull-requests
https://github.com/CDE-UNIBE/qcat/pull/48
https://qcat-dev.wocat.net/

Yes, you will need to run the script (python manage.py runscript technologies_2018) on the server (in /srv/webapps/qcat-dev) so that the values are
updated. You will most probably have to activate the virtual environment first (source /srv/webapps/qcat-dev/virtualenv/bin/activate).

| hope this helps?

Best regards,
Lukas

#19 - 04 Nov 2019 14:40 - Kurt Gerber

- Assignee changed from Lukas Vonlanthen to Tatenda Lemann

The new values below section 3 are now added in hitps://gcat-dev.wocat.net.
Could you, or anybody else, please check, if that is ok?

When you give me the 'ok’, | will deploy it on production (https:/gcat.wocat.net).

#20 - 07 Nov 2019 02:10 - Brahadeesh Dheenadayalan_Sivakami

- Assignee changed from Tatenda Lemann to Kurt Gerber

Hi Kurt,

| can confirm that the new values are now showing up in their respective dropdown lists.

Thanks,
Guhan

#21 - 07 Nov 2019 15:58 - Kurt Gerber

- Status changed from Feedback to Resolved

#22 - 17 Dec 2019 09:22 - Kurt Gerber

- Status changed from Resolved to Closed

Files

LUT lists_FINAL.docx 48.7 KB 12 Jul 2019 Redmine Admin

LUT lists-newvalues.xlsx 11.4 KB 02 Sep 2019 Brahadeesh Dheenadayalan_Sivakami

apps_configuration.tar 10 KB 06 Sep 2019 Brahadeesh Dheenadayalan_Sivakami
